// ̧قDoxygenpɏĂ܂B
/*! \file *********************************************************************
*
* Atmel Corporation
*
* - ̧		: hallsensor_two_phase_BLDC.c
* - ߲		: IAR EWAAVR 3.20c
*
* - xҰ		: avr@atmel.com
*
* - x޲	: 2PWMo͕t8ޯ /2ADCق޲g
*				  pł܂BATtiny13pɏĂ܂B
*
* - pLq	: AVR442 - ATtiny13pPÇݐ
*
* - 		: ΰيmt2׼ڽDCӰ̐
*				  WPÇݗpɍ쐬ꂽ
*
* $Revision: 1.2 $
* 		: Robert Staven, Atmel Corp.
* $Author: rstaven $, Atmel Corp.
* $Date: Friday, June 24, 2005 08:17:02 UTC $
******************************************************************************/

#include <iotiny13.h>
#include <inavr.h>
#include "hallsensor_two_phase_BLDC.h"

//! Ӱd͂ɎgpPWMMޭè 
unsigned char coilDuty = 0xFF;
//! ŌΰيmM玞Ԍv
unsigned int stallTime = 0;
//! ~Ԓߗpx쐬Ɏgp
unsigned long delayCounter = 0;

/*! \brief Flags Ӱԗp
 */
struct GLOBAL_FLAGS {
  //! Ӱ~ɐ^
  unsigned char stall:1;
  //! Ӱnɐ^
  unsigned char starting:1;
  //! xŐ^
  unsigned char alarm:1;
  unsigned char dummy:5;
} gFlags = {FALSE, TRUE, FALSE, 0};

//! PWM͒lpɎgpQƕ\
__flash unsigned char LUT_for_PWM[] = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 22, 24, 26,
									   28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 56, 58,
									   60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 90,
									   92, 94, 95, 98,101,104,107,110,113,116,119,122,125,128,131,135};

//! н͒lpɎgpQƕ\
__flash unsigned char LUT_for_Thermistor[] = {255,255,255,248,241,234,227,220,213,206,199,192,185,178,171,163,
											  156,149,142,135,128,121,113,106, 99, 92, 85, 78, 71, 64, 55, 48,
											   41, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35};

/*! \brief ̧ݐ
 *
 * ̧ݎnAxPWM_Inǂ݁APWMޭèݒ
 * ~oA~ҋ@ƍĎn
 */
void main( void )
{
  unsigned int t_ad;					// нA/Dϊl
  unsigned char t_idx;					// нLUTwW
  unsigned int pwm_ad;					// PWM_InA/Dϊl
  unsigned int duty;					// ޭè(colDuty)ꎞl

  init();								// 평
  startFan();							// ̧ݎn

  while(1)
  {
	t_ad = ADC_read(1);					// нǂݎ
	if(t_ad < 256)						// LUT256`639A/DϊlԗÂ0`47̎wWێ
	  t_idx = 0;
	else if(t_ad >= 640)
	  t_idx = 47;
	else
	  t_idx = (t_ad/8)-32;

	pwm_ad = ADC_read(2);				// PWM_In͓ǂݎ
	duty = (LUT_for_PWM[pwm_ad/16] * LUT_for_Thermistor[t_idx]) >> 7;	// Ӱd͌vZ
	if(duty > 255)						//  ޭè255܂łɐ
	  duty = 255;
	if(gFlags.starting == FALSE)		// nȊOŁA
	  coilDuty = duty;					// ޭèXV(nޭèXVȂ)

	// Stalled rotor, raise alarm, power off, wait and restart
	if(gFlags.stall == TRUE){			// ̧ݒ~ȂA
	  gFlags.alarm = TRUE;				// x׸ސݒ
	  PORTB |= (1 << PB5);				// xo=H(xON)ݒ
	  coilDuty = 0;						// dOFFw
	  delayCounter = 0;					// ~Ԓߌvؾ
	  while(delayCounter <= STALLTIMEOUT);		// ~ҋ@(10b)
	  gFlags.alarm = FALSE;				// x׸މ
	  PORTB &= ~(1 << PB5);				// xo=L(xOFF)ݒ
	  stallTime = 0;					// ~Ďv평
	  gFlags.stall = FALSE;				// ̧ݒ~׸މ
	  startFan();						// ̧ݍĎn
	}
  }
}

/*! \brief ΰِMω荞ݏٰ
 *
 * ق̊ƒ~Ďvؾ
 */
#pragma vector = PCINT0_vect
__interrupt void pin_change(void)
{
  gFlags.starting = FALSE;				// ̧ݎn׸މ(ΰيmMωȂ̂ŉ]qnÂ̧ݎnI)
  coilActivate();						// ق
  stallTime = 0;						// Ōΰيmω̎Ԍv평
}

/*! \brief /0ꊄ荞ݏٰ
 *
 * /0ꊄ荞 - 18750Hz
 * قޭèݒA~Ďvƒ~vis
 */
#pragma vector = TIM0_OVF_vect
__interrupt void TIM0_OVF(void)
{
  OCR0A = coilDuty;						// rAޭèlݒ
  OCR0B = coilDuty;						// rBޭèlݒ

  if(stallTime < STALL_LIM)				// ~ĎԓŁA
	stallTime++;						// ~ĎԌvis
  else									// ~ĎԌo߂ŁA
	gFlags.stall = TRUE;				// ̧ݒ~׸ސݒ

  if(delayCounter < 0xFFFFFFFF)			// ~ԌvőlŁA
	delayCounter++;						// ~Ԍvis
  return;
}

/*! \brief 
 */
#pragma inline=forced
void init(void)
{
  CLKPR = (1 << CLKPCE);				//  ۯOuȂݒ(=4.8MHz ۯ)
  CLKPR = 0;
  DDRB = (1 << PB5) | (1 << PB1) | (1 << PB0);		// ̧ ِpOC0AOC0Bƌxo͂PB5o͂ɐݒ

  Init_TC0();							// /0
  Init_ADC();							// A/Dϊ평

  PCMSK = IO_HALL;						// ΰيmpݕω荞݋
  GIMSK |= (1 << PCIE);

  __enable_interrupt();					//<! S̊荞݋
}

/*! \brief /0PWMŏ
 *
 * \note ֐1xĂ΂A(I)ײ݉ł܂B
 */
#pragma inline=forced
void Init_TC0( void )
{
  TCCR0A = (1<<WGM01)|(1<<WGM00);		// PWMݒ
  TCCR0B = (0<<WGM02) | (1<<CS00);		// OuȂŎn
  TCNT0 = 0;							// /0
  TIMSK0 |= (1<<TOIE0);					// /0ꊄ荞݋
}

/*! \brief A/Dϊ평Ə[ϊs
 *
 * \note ֐1xĂ΂A(I)ײ݉ł܂B
 */
#pragma inline=forced
void Init_ADC( void )
{
  ADMUX = 2;							// VCCd,͂ƂADC2(PB4)ݒ
  ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1);		// ADC,64Ouۯݒ

  ADCSRA |= (1<<ADSC);					// [ϊJn
  while (ADCSRA & (1<<ADSC));			// ϊҋ@
  ADCSRA = ADCSRA;						// A/Dϊ荞ݗv׸މ

}

/*! \brief ̧ݎn
 *
 *  ޭènlɐݒA̧ݎn
 */
void startFan(void)
{
  gFlags.starting = TRUE;				// ̧ݎn׸ސݒ
  coilDuty = STARTPWMDUTY;				// ޭèlnlɐݒ
  coilActivate();						// ي
}

/*! \brief ΰيmǂݎƐق̊
 */
void coilActivate(void)
{
  if ((PINB & IO_HALL) == 0){			// ΰيmo=L(2ًd)ŁA
	TCCR0A &= ~(1 << PWM1A);			// OC0A(PB0)=OFF
	TCCR0A |= (1 << PWM1B);				// OC0B(PB1)=ON
  }
  else{									// ΰيmo=H(1ًd)ŁA
	TCCR0A &= ~(1 << PWM1B);			// OC0B(PB1)=OFF
	TCCR0A |= (1 << PWM1A);				// OC0A(PB0)=ON
  }
}

/*! \brief ADC͓ǂݎ
 */
int ADC_read(char input)
{
  int ADC;								// ΰيmA/Dϊl

  ADMUX = (0<<REFS0) | (0x07&input);	// VCCd,ΰيmADCِݒ
  ADCSRA |= (1 << ADIF) | (1<<ADSC);	// ϊ׸މ,ϊJn
  while(!(ADCSRA & (1 << ADIF)));		// A/Dϊҋ@
  ADC = ADCL;							// ϊl޲Ď擾
  ADC += (ADCH << 8);					// 10ޯA/Dϊl擾
  return ADC;
}
